/* Copyright 2020-2025, Michele Santullo
 * This file is part of memoserv.
 *
 * Memoserv is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Memoserv is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Memoserv.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <cstdint>
#include <memory>

namespace dhandy {
template <typename T, typename I, std::size_t A>
class PackedPointer;
} //namespace dhandy

namespace mc::psx {
std::uint8_t* to_block_aligned (std::uint8_t* ptr, std::size_t index=0, std::ptrdiff_t base_offs=0);
const std::uint8_t* to_block_aligned (const std::uint8_t* ptr, std::size_t index=0, std::ptrdiff_t base_offs=0);
bool is_block_aligned (const std::uint8_t* ptr);

template <typename T, std::size_t A>
bool is_block_aligned (const dhandy::PackedPointer<T, std::size_t, A>& ptr);

std::unique_ptr<std::uint8_t[]> make_unique_for_block_aligned(std::size_t size);
} //namespace mc::psx
